<template>
    <div class="addCoin row">
        <div>
            <div  class="input-container"
                :class="{
                    'open' : isWeatherOpen,
                    'close' : !isWeatherOpen,
                }"><input v-if="isWeatherOpen" v-model="inputValue" type="text" placeholder="the name of the city" class="input">
            </div>
            <div v-if="inputValue != '' " class="serchingList">
                <div v-if="searchingList.length" class="list">
                    <div v-for="city in searchingList" @click="changeChosenCity(city.name), console.log(city.name), getWeatherNow(city.name), inputValue = '', weatherOpenChange()" :key="city.id" class="serchingItem">{{city.name}}, {{city.country}}</div>
                </div>
                <div v-else class="notMatch">
                    <div class="serchingItem">Not Match</div>
                </div>
            </div>
        </div>
    </div> 
</template>

<script>
    
    import { mapMutations, mapGetters } from 'vuex';
    import generalList from './cityList.json'

    export default {
        props: {
            getWeatherNow: {
                type: Function,
                required: true
            }
        },  
        data() {
            return {
                isOpen: false,
                inputValue: '',
                cityList: []
            }
        }, 
        methods: {
            ...mapMutations(['changeChosenCity', 'weatherOpenChange']),
            isOpenMeth() {this.isOpen ? this.isOpen = false : this.isOpen = true},
            isOpenClass() {
                if (this.isOpen) { return 'opened' }
                else { return'closed' }
            },
        },
        mounted() {
            this.cityList = generalList
        },
        computed: {
            ...mapGetters(['isWeatherOpen']),
            searchingList() {
                return [...this.cityList].filter(city => city.name.toLowerCase().includes(this.inputValue.toLowerCase()))
            }
        }
    }
</script>

<style scoped>
    .addCoin {
        justify-content: start;
    }
    .input-container {
        overflow: hidden;  
        transition: all 0.8s ease-out;
    }

    .input {
        width: 350px;
        border: none;
        box-shadow: inset 1px 1px 5px gray;
        font-family: 'Orbitron', sans-serif;
        font-size: 20px;
        height: 40px;
        padding: 5px 12px;
    }
    .close {
        height: 0;
        transition: height 1s ease-in;
        padding: 0;
    }
    .open {
        height: 50px;
        margin-bottom: 10px;
    } 
    input:focus {
        border: none;
        outline: none;
    }
    .icon {
        border-end-start-radius: 0;
        border-start-start-radius: 0;
        border-start-end-radius: 15px;
        border-end-end-radius: 15px;
        width: 45px;
        margin-right: 10px;
    }
    .plus {
        width: 30px;
        height: 30px;
        align-self: center;
        background-position: center;
        background-size: contain;
        background-repeat: no-repeat;
    }
    .addCoin div.closed {
        background-image: url(@/icon/plus.png);
        transition: .3s;
    }
    .addCoin div.opened {
        background-image: url(@/icon/cross.png);
        transition: .3s;
    }
    .serchingList {
        position: absolute;
    }
    .serchingItem {
        color: white;
        background-color: rgba(90, 90, 90, 0.9);
        padding: 5px;
        width: 364px;
        font-size: 20px;
    }
    .serchingItem:hover {
        background-color: rgba(90, 90, 90, 1);
        box-shadow: inset 1px 1px 5px rgb(187, 187, 187);
        
    }
</style>